import java.awt.* ;
import java.awt.event.* ;

class FenetreDessin extends Frame {
	protected Ardoise ad ;
	protected Delegue delegue  ;
	protected Adaptateur adapt ;
    //...

	FenetreDessin() {
		setLayout(new BorderLayout()) ;
		ad = new Ardoise(500,500); 
		add("Center", ad) ;
		//...
		delegue = new Delegue(ad); // le delegue recoit l'adresse de l'ardoise
		adapt = new Adaptateur(delegue) ;
		// l'adaptateur doit surveiller les mouvements de la souris :
		ad.addMouseMotionListener(adapt);
		ad.addMouseListener(adapt);
		//...
                this.addWindowListener(adapt);
		}
	}

class Ardoise extends Canvas {	// classe derivant de Canvas
	protected Image im ;		// l'image dessinee
        protected Graphics gr ;		// le contexte graphique de l'image
	protected int x, y, xo, yo ;	// coordonnees de la souris
	protected int largeur, hauteur ;

	Ardoise(int a, int b) {		// constructeur
		largeur = a ;
		hauteur = b ;
	        setSize(largeur,hauteur);
		gr = null ;
                }

	public void paint(Graphics g) {	// methode d'affichage
	        if (gr == null) {		// initialisation au demarrage
			setBackground (Color.cyan) ;
			im = createImage(largeur, hauteur) ;
		       	gr = im.getGraphics() ;
		       		} 
		g.drawImage(im,0,0,this) ;	// affichage de im
		}
	}

public class Dessin {
	public static void main(String[] args) {
		FenetreDessin f = new FenetreDessin();
                f.pack();
                f.setLocationRelativeTo(null); //the window is placed in the center of the screen.
		f.setVisible(true); 
		}
	}

class Delegue {
	protected Ardoise ard ; 

	Delegue(Ardoise a) {
		ard = a ;
		}

	public void tiresouris(MouseEvent e) {
		ard.x=e.getX() ; ard.y=e.getY() ; 
		if (ard.gr != null) {
			ard.gr.drawLine(ard.xo, ard.yo, ard.x , ard.y) ;
			ard.xo = ard.x ; ard.yo = ard.y ;		
			}
		ard.repaint();
		}

	public void pressesouris(MouseEvent e) {
		ard.xo=e.getX() ; ard.yo=e.getY() ; 
		}

    //...

       public void exit() {
		System.exit(0);
		}
	}

class Adaptateur implements MouseListener, MouseMotionListener, WindowListener  { //changer
	protected Delegue delegue ;

	public Adaptateur(Delegue d) {
		delegue = d ;
		}

	public void mouseDragged(MouseEvent e) {
		delegue.tiresouris(e) ;
		}

	public void mouseMoved(MouseEvent e) {
		}

	public void mousePressed(MouseEvent e) {
		delegue.pressesouris(e) ;
		}

	public void mouseClicked(MouseEvent e) {
		}

	public void mouseReleased(MouseEvent e) {
		}

	public void mouseEntered(MouseEvent e) {
		}

	public void mouseExited(MouseEvent e) {
		}
    //...
        public void windowOpened (WindowEvent e) {}
	public void windowClosing (WindowEvent e) { // ferme la fenetre
		delegue.exit();
		}
	public void windowClosed (WindowEvent e) {}
	public void windowIconified (WindowEvent e) {}
	public void windowDeiconified (WindowEvent e) {}
	public void windowActivated (WindowEvent e) {}
	public void windowDeactivated (WindowEvent e) {}
	}
