import java.awt.* ;
import java.awt.event.* ;

class FenetreGeometrique extends Frame {
 	protected Ardoise ad ;
	protected Panel p ;
	protected Button effacer ;
	protected Delegue delegue ;
	protected Adaptateur adaptateur ;

	FenetreGeometrique() {
		setLayout(new BorderLayout());
		ad = new Ardoise(500,500); 
		add("Center", ad) ;

		p = new Panel() ;
                delegue = new Delegue(this);
		adaptateur = new Adaptateur(delegue) ;
		effacer = new Button("effacer") ;
		p.add(effacer); 
		effacer.addActionListener(adaptateur) ;
		add("South", p) ;

		ad.addMouseMotionListener(adaptateur);
		ad.addMouseListener(adaptateur);
                this.addWindowListener(adaptateur);
		}
}	

class Ardoise extends Canvas {	// classe derivant de Canvas
	protected Image im ;			 // l'image dessinee
        protected Graphics gr ;			// le contexte graphique de l'image
        protected int x, y, xo, yo ;		// coordonnees de la souris
	protected int largeur, hauteur ;

	Ardoise(int a, int b) {		// constructeur
		largeur = a ;
		hauteur = b ;
	        setSize(largeur,hauteur);
		gr = null ;
                }
 
	public void paint(Graphics g) {	// methode d'affichage
	    		if (gr == null) {			// initialisation au demarrage
			setBackground (Color.white) ;
			im = createImage(largeur, hauteur) ;
		       	gr = im.getGraphics() ;
		       	} 
		g.drawImage(im,0,0,this) ;	// affichage de im
		}
	}


public class Geometrique {
	public static void main(String[] args) {
		FenetreGeometrique f = new FenetreGeometrique();
                f.pack();
                f.setLocationRelativeTo(null); //the window is placed in the center of the screen.
		f.setVisible(true); 
		}
	}
class Delegue {
    	FenetreGeometrique forme ; 

    	Delegue(FenetreGeometrique t) {
		forme = t ;
		}
    
	public void boutonEnfonce(MouseEvent e) {
	       	forme.ad.xo = e.getX();
                forme.ad.yo = e.getY() ;
		}

	public void sourisTiree(MouseEvent e) {
		forme.ad.x=e.getX() ; 
                forme.ad.y=e.getY() ; 
		if (forme.ad.gr != null) {
		    forme.ad.gr.drawLine(forme.ad.xo, forme.ad.yo, forme.ad.x , forme.ad.y) ;
		    }
		forme.ad.repaint();
		}

	public void nettoyer(ActionEvent e) {
	        forme.ad.gr.clearRect(0,0,forme.ad.largeur,forme.ad.hauteur);
		forme.ad.repaint(); 
		}

       public void exit() {
		System.exit(0);
		}
}

class Adaptateur implements MouseMotionListener, MouseListener, ActionListener, WindowListener  {
	protected Delegue delegue ;

	public Adaptateur(Delegue d) {
		delegue = d ;
		}

	public void mousePressed(MouseEvent e) {
		delegue.boutonEnfonce(e) ;
		}

	public void mouseDragged(MouseEvent e) {
		delegue.sourisTiree(e) ;
		}

        public void mouseMoved(MouseEvent e) {}
        public void mouseClicked(MouseEvent e) {}
        public void mouseReleased(MouseEvent e) {}
        public void mouseEntered(MouseEvent e) {}
        public void mouseExited(MouseEvent e) {}

	public void actionPerformed(ActionEvent e) {
		delegue.nettoyer(e) ; 
		}

        public void windowOpened (WindowEvent e) {}
	public void windowClosing (WindowEvent e) { // ferme la fenetre
		delegue.exit();
		}
	public void windowClosed (WindowEvent e) {}
	public void windowIconified (WindowEvent e) {}
	public void windowDeiconified (WindowEvent e) {}
	public void windowActivated (WindowEvent e) {}
	public void windowDeactivated (WindowEvent e) {}
}
